﻿/* **************************************************************************
 *
 * Copyright 2007-2010 Jeff Hardy
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * *************************************************************************/

using System.Collections.Generic;

namespace NWSGI
{
    public enum FrameOptions
    {
        Off, On, Full
    }

    public enum CompilationOptions
    {
        Adaptive, Compiled
    }

    public interface IWsgiConfig
    {
        CompilationOptions Compilation { get; }
        bool DebugMode { get; }
        bool EnableExtensions { get; }
        bool EnableProfiler { get; }
        FrameOptions Frames { get; }
        bool HasWildcard { get; }
        bool LightweightScopes { get; }
        bool Tracing { get; }
        IWildcardInfo Wildcard { get; }

        IEnumerable<string> PythonPaths { get; }
        IEnumerable<IScriptMappingInfo> ScriptMappings { get; }
        IEnumerable<KeyValuePair<string, string>> WsgiEnviron { get; }
    }

    public interface IWildcardInfo
    {
        string PhysicalPath { get; }
        string Callable { get; }
    }

    public interface IScriptMappingInfo
    {
        string ScriptName { get; }
        string PhysicalPath { get; }
        string Callable { get; }
    }
}
