﻿/* **************************************************************************
 *
 * Copyright 2007-2010 Jeff Hardy
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * *************************************************************************/

using System;
using System.Collections.Generic;
using System.IO;

namespace NWSGI
{
    public interface IWsgiRequest
    {
        string Method { get; }

        string ScriptName { get; }
        string PathInfo { get; }
        string QueryString { get; }

        string ContentType { get; }
        string ContentLength { get; }

        string ServerName { get; }
        string ServerPort { get; }
        string ServerProtocol { get;}

        IEnumerable<KeyValuePair<string, string>> Headers { get; }
        IEnumerable<KeyValuePair<string, string>> CgiServerVariables { get; }

        Uri Url { get; }
        string RawUrl { get; }

        Stream InputStream { get; }
    }
}
