﻿/* **************************************************************************
 *
 * Copyright 2007-2010 Jeff Hardy
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * *************************************************************************/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NWSGI.Tests
{
    class StubRequest : IWsgiRequest
    {
        public StubRequest()
            : this("http://example.com") { }

        public StubRequest(string url)
        {
            this.RawUrl = url;
            this.Url = new Uri(url);
            this.Headers = this.CgiServerVariables = Enumerable.Empty<KeyValuePair<string, string>>();
        }

        public string Method { get; set; }

        public string ScriptName { get; set; }

        public string PathInfo { get; set; }

        public string QueryString { get; set; }

        public string ContentType { get; set; }

        public string ContentLength { get; set; }

        public string ServerName { get; set; }

        public string ServerPort { get; set; }

        public string ServerProtocol { get; set; }

        public IEnumerable<KeyValuePair<string, string>> Headers { get; set; }

        public IEnumerable<KeyValuePair<string, string>> CgiServerVariables { get; set; }

        public Uri Url { get; set; }

        public string RawUrl { get; set; }

        public System.IO.Stream InputStream { get; set; }
    }
}
